# Called from the factorial typology output sheet, this
# generates the ranking report page for the join of the 
# selected languages.

require_relative '../lib/excel'
require_relative '../lib/comparative_tableau'
require_relative '../lib/derivation_hash'
require_relative '../lib/hierarchy'
require_relative '../lib/fred'
require 'REXML/syncenumerator' # Ruby 1.9 moved syncenumerator to REXML.

# Create a ruby-excel session, and connect it to the existing
# (running) instance of excel.
sess = Excel_session.new
sess.connect_to_excel

#sess.display_ok_box('Mojo for HS coming soon!')

# Consists of arrays containing: lang name & hierarchies
lang_list_num = sess.get_ft_lang_and_orders 

# Gets the competitions from a VT and returns them in a list
sess.move_active_sheet_back 
inputs, ops, constraints = sess.get_hs_op_input_sheet_data
sess.move_active_sheet_forward

lang_list = Array.new
lang_list_num.each do |ll|
  ll_ar = Array.new
  con_hier = Hierarchy.new
  ll_ar << ll[0] << con_hier
  pos = ll[1].split('.')
  pos.each {|p| con_hier << [constraints[p.to_i]] unless p == ""}
  lang_list << ll_ar
  
end

fred_results = Array.new
lang_list.each do |lang|
  lang_label, hier = lang
  dh = Derivation_Hash.new
  cons = Array.new
  # Assumes hier is a total order
  hier.each {|strat| cons << strat[0]}
  dh.create_derivations_for_total_order(inputs, ops, cons)
  fred_result = Fred.new(dh.get_comparative_tableau)
  
  fred_result.label=lang_label
  fred_results << fred_result
end

mojo_result = Mojo.new(fred_results)
sess.put_mojo(mojo_result.fred_result, fred_results, false)    #This has 3 args: 3rd is con_check (Boolean)
sess.nameMOJO

# Pop up a botton box indicating finished.
sess.display_ok_box('Mojo done!')
