# Called from a op sheet, this
# generates the harmonic serialism factorial typology for the ops, inputs, & constraints on the sheet.

require_relative '../lib/excel'
require_relative '../lib/comparative_tableau'
require_relative '../lib/fred'
require_relative '../lib/factorial_typology_hs_op'
require 'REXML/syncenumerator' # Ruby 1.9 moved syncenumerator to REXML.

# Create a ruby-excel session, and connect it to the existing
# (running) instance of excel.
sess = Excel_session.new
sess.connect_to_excel
# Gets the competitions from a VT and returns them in a list
inputs, ops, constraints = sess.get_hs_op_input_sheet_data

ft = Factorial_Typology_HS_Op.new(inputs, ops, constraints)

ft.langs.each {|d_ht| puts; d_ht.values.each {|d| puts d.get_comparative_tableau}}
ft.get_languages_as_comparative_tableau.each {|ct| puts; puts ct}

# Displays languages' derivations, one for each input
# Langs contains hash tables whose keys are the inputs & vals are derivations
sess.put_ft_hs_ops(ft.langs, inputs, ft)  

if sess.display_yesno_box("Display ranking info for all #{ft.langs.length} languages?")
  fred_results = Array.new
  count = 0
  ft.langs.each do |lang|
    count += 1
    # Call FRed on lang
    fred_result = Fred.new(ft.get_comparative_tableau(lang))
    # Create new ws, put ct and skb info to it
    fred_result.label="L#{count.to_s}"
    sess.put_ft_hs_cand_skb(fred_result, lang)
  end
end

=begin
if sess.display_yesno_box("Display all optima?")
  outs = ft.get_undifferentiated_outputs
  outs.each {|o| puts o.to_s}

end
=end

# Pop up a botton box indicating that RUBOT is finished.
sess.display_ok_box('HS Fact Typ Done!')

