LOGFILE = File.open('rubot19.log', 'a')
LOGFILE.puts("\n\n#{Time.now}  #{__FILE__} begin\nARGV: #{ARGV}")
begin

# CallRubyScript2
require File.expand_path '../../lib/excel', __FILE__
require File.expand_path '../../lib/gen', __FILE__
require File.expand_path '../../lib/correspondence', __FILE__

# Gen.gen_two
raise "Gen.gen_two: Wrong number of parameters (#{ARGV.size} of 5)" if ARGV.size != 5
FirstRow,LastRow,InputCol,OutputCol = ARGV[0..3].map {|x| x.to_i}
pars = ARGV[4].strip
pars = pars[1..-2] if pars[0] == '('
pars = pars.strip.split(',').map(&:strip)

input_len = 2
cand_len = 3
corresp = false
input_len = pars[0].to_i if pars.size >= 1
cand_len = pars[1].to_i if pars.size >= 2
corresp = pars[2] != '0' && pars[2].upcase != 'FALSE' if pars.size >= 3
LOGFILE.puts("pars: #{input_len}, #{cand_len}, #{corresp}")

sess = Excel_session.new
sess.connect_to_excel

excel = sess.instance_eval "@excel"
#excel.ScreenUpdating = false
workbook = excel.ActiveWorkbook
worksheet = workbook.ActiveSheet

def conv(input)
  result = []
  i = 1
  input.each_char do |c|
    case c
    when 'X'
      result << 'X'
      i+=1
    when 'e', 'p'
      result << c
    else
      result << i.to_s
      i+=1
    end
  end
  "#{input.gsub('X','').gsub('e', 'V').gsub('p', 'C')} #{result.join(',')}"
end

filters = []
posreqs = []            #hold positive requirements that must be met
epenthesis = ['e', 'p']
kvs = {}
old_gen_vals = nil
(FirstRow..LastRow).each do |row|
  macro = worksheet.Cells(row, InputCol-1).value.to_s.strip
  regexp = worksheet.Cells(row, InputCol).value.to_s.strip
  if macro == 'not'
    regexp = "/#{regexp}/" if regexp[0] != '/'
    filters << eval(regexp)  #TODO, must form well regexp
    next               
  elsif macro == 'must'	#ADDITION: following above for not.AP.                        
    regexp = "/#{regexp}/" if regexp[0] != '/'
    posreqs << eval(regexp)  #TODO, must form well regexp
    next 
  elsif macro == 'epenthesis'
    epenthesis = regexp.split(',').map(&:strip)
    next
  end
  regexp.gsub!(/\s+/, '')
  if macro != '' && regexp != ''
    begin
      lexicon = regexp.scan(/[A-Z]|[a-z]/).uniq.join
      %w{\. \? \+ \- \*}.each { |xx| lexicon << xx[1] if regexp.include?(xx) }
      if !old_gen_vals
        LOGFILE.puts "  row:#{row},input:#{macro}  Gen.gen_one('#{regexp}', #{input_len}, true, '#{lexicon}')"
        res = Gen.gen_one(regexp, input_len, true, lexicon)
        old_gen_vals = res
      else
        LOGFILE.puts "  row:#{row},macro:#{macro}  Gen.gen_one('#{regexp}', #{input_len}, true, '#{lexicon}')"
        res = Gen.gen_one(regexp, cand_len, true, lexicon)
        kvs[macro] = res
      end
    rescue Exception => erx
      res = erx.to_s + "\n\n" + erx.backtrace.join("\n")
    end
    worksheet.Cells(row, OutputCol).value = res.inspect
  end
end
#old_gen_vals.delete('')

LOGFILE.puts "  input: #{old_gen_vals} "
LOGFILE.puts "  other: #{kvs} "
LOGFILE.puts "  filters: #{filters} "
LOGFILE.puts "  epenthesis: #{epenthesis} "

a_vals = []
old_gen_vals.each do |x|
  vs = x.each_char.map do |c|
    v = kvs[c]
    v ? v : c
  end

  LOGFILE.puts "    vs p1: #{vs}"
  vs2 = vs.reduce { |x,y| x.product y }
  vs2.map! { |x| x.join('$') } if vs2.size > 0 && vs2[0].is_a?(Array)
  a_vals << [x, vs2]
end

newsheet = workbook.worksheets.Add(:After=>worksheet)
newsheet.Name = "newGen #{Time.now.strftime '%Y%m%d-%H%M%S'}"
# header
newsheet.Cells(1, 1).value = "Please wait ...."
newsheet.Cells(1, 2).value = "VT.ini"
newsheet.UsedRange.Columns.AutoFit
newsheet.Cells(2, 1).value = 'input'
newsheet.Cells(2, 2).value = 'output'
newsheet.Cells(2, 3).value = 'opt'

# stress       -What does this comment indicate? -AP
row = 3
a_vals.each do |x, yy|
  newsheet.Cells(row, 1).value = x
  yy.each do |y|
    if filters.any? { |reg| reg =~ y.gsub('$', '') } #filter 'not' regexp(s)
      LOGFILE.print "   x,y = #{x}, #{y}.  discard\n"
      next
    end
    #ADDITION  following above. AP.
    if posreqs.any? { |reg| reg !~ y.gsub('$', '') } #filter 'must' regexp(s)
      LOGFILE.print "   x,y = #{x}, #{y}.  discard\n"
      next
    end

    if corresp
      y2 = corr(x,y,epenthesis)
      LOGFILE.print "   x,y,y2 = #{x}, #{y}, #{y2}\n"
    else
      y2 = y.gsub('$', '')
      LOGFILE.print "   x,y = #{x}, #{y}\n"
    end

    newsheet.Cells(row, 2).value = y2
    row += 1
  end
end

newsheet.Cells(1, 1).value = ''
newsheet.UsedRange.Columns.AutoFit

#sess.display_ok_box("CallRubyScript2 #{__FILE__}   Done!")


rescue Exception => eee
  LOGFILE.puts(eee)
  LOGFILE.puts("--------------------------------")
  LOGFILE.puts(eee.backtrace)
ensure
  LOGFILE.puts("#{Time.now}  #{__FILE__} end\n")
  LOGFILE.close
  #excel.ScreenUpdating = true
end
