# Author: Bruce Tesar
# RCD only, starting from a VT.

require_relative '../lib/excel'
require_relative '../lib/comparative_tableau'
require_relative '../lib/rcd'

# Create a ruby-excel session, and connect it to the existing
# (running) instance of excel.
sess = Excel_session.new
sess.connect_to_excel

# Read in the active worksheet, which is assumed to be
# a properly formatted violation tableau (VT), and store
# the data as a competition list.
competition_list = sess.get_input_sheet_data

# Generate a comparative tableau from the competition list.
ct = Comparative_tableau.new(competition_list.label)
ct.add_competition_list(competition_list)

# Run RCD on the comparative tableau, and put the results
# to a new worksheet in excel.
rcd_result = Rcd.new(ct)
sess.put_rcd_results(rcd_result)

# If RCD determines that the data are inconsistent, pop
# up a message box to that effect.
if !rcd_result.consistent? then
  sess.display_ok_box('Data are inconsistent!')
end

# Pop up a botton box indicating that RUBOT is finished.
sess.display_ok_box('Done!')
