# Author: Nazarre Merchant
#

# A HS operation that produces the faithful candidate

require_relative 'constraint.rb'
require_relative 'candidate_hs.rb'
require_relative 'operation.rb'

class Faithful_Operation < Operation

  def create_candidates(input)
    # Roopa specific mods
    qi_foot = false
    #paka = true
    paka = false
    
    return qi(input) if qi_foot
    return pak(input) if paka
    return standard_faith(input)
  end
  
  def standard_faith(input)
    c = HS_Candidate.new(input, input, false, @cons, self)
    # Default assump is that the faithful candidate is base.
    c.base=true
    cands = [c]
    set_violations(cands)
    return cands
  end
  
  def qi(input)
    no_faith = [".o.", ".oo.", ".ooo.", ".oooo.", ".ooooo."]
    return [] if no_faith.include?(input)
    return standard_faith(input)
  end
  
  def pak(input)
    count = 0
    input.split("").each {|c| count = count + 1 if /[A-Z]/.match(c) != nil}
    return [] if count != 1
    return standard_faith(input)
  end




end