# Called from a vt sheet, this
# generates the harmonic serialism factorial typology for the competitions on the sheet.

require_relative '../lib/excel'
require_relative '../lib/comparative_tableau'
require_relative '../lib/fred'
require_relative '../lib/factorial_typology_hs'
require 'REXML/syncenumerator' # Ruby 1.9 moved syncenumerator to REXML.

# Create a ruby-excel session, and connect it to the existing
# (running) instance of excel.
sess = Excel_session.new
sess.connect_to_excel
# Gets the competitions from a VT and returns them in a list
competition_list = sess.get_input_sheet_data

fact_type = FactorialTypologyHS.new(competition_list)
# The language list is a list of comparative tableaux
lang_list = fact_type.factorial_typology
sess.put_ft_hs(lang_list, fact_type.competition_list)

if sess.display_yesno_box("Display ranking info for each language?")
  fred_results = Array.new
  lang_list.each do |lang|

    # Call FRed on lang
    fred_result = Fred.new(lang)
    # Create new ws, put ct and skb info to it
    sess.put_ft_hs_cand_skb(fred_result)
  end
end

# Pop up a botton box indicating that RUBOT is finished.
sess.display_ok_box('HS Fact Typ Done!')

