# Author: Naz Merchant

require_relative 'hierarchy.rb'

# A repository for often-needed methods 

class OT_Utilities
  
  def self.create_all_permutations_as_hierarchies(cons)
    hiers = Array.new
    orders = OT_Utilities.create_all_permutations(cons)
    orders.each do |o|
      h = Hierarchy.new
      o.each {|c| h << [c]}
      hiers << h
    end
    return hiers
  end
  
  def self.create_all_permutations(cons)
    orders = OT_Utilities.continue_sequence(cons)
    return orders
  end

  def self.continue_sequence(cons)
    continue_set = Set.new
    cons.each do |c|
      if cons.length > 1
        cons_wo_c = Array.new(cons)
        cons_wo_c.delete(c)

        sets = continue_sequence(cons_wo_c)
        sets.each do |seq|
          order = Array.new
          order << c
          order.concat(seq)
          continue_set.add(order)
        end
      else
        # Length here should be 1, meaning that we've reached the end of the
        # constraint set, and so a new order should be created with c in it.
        order = Array.new
        order << c
        continue_set.add(order)
      end
    end

    return continue_set
  end
end