# Author: Naz Merchant
#

require_relative 'competition'

# A path is ordered set of competitions.  Each competition
# has exactly one candidate marked as optimal (even if there are co-optima). The ordering on
# the competitions is the obvious one: the winning candidate's output should match the next 
# competition's input.
#
# Currently there is no checked that this is a viable path, amongst other things 
# that could go wrong there is no checking that there is a viable ranking that maps input to output.

class Path < Array

    def to_s
      return "Empty" if self.empty?
      s = self[0][0].input
      # Warning: each competition added to path should have exactly one winner 
      self.each {|comp| s = "#{s} -> #{(comp.winners)[0].output}"}

      return s
    end
    
    def get_final_optima
      self[self.length-1].winners[0].output
    end

end