# Author: Naz Merchant
#

# A HS operation that produces the faithful candidate

require_relative '../../lib/operation_epen.rb'

require_relative 'bst_parser.rb'
require_relative 'candidate_bst.rb'

class Epenthesis_Operation_BST < Epenthesis_Operation

  def initialize(name, source, target, constraints, parser)
    super(name, source, target, constraints)
    @parser = parser
  end

  def create_candidates(input)
    cands = Array.new
    super(input).each do |c|
      @parser.parse(c.output).each {|o| cands << BST_Candidate.new(input, o, false, @cons, self, @parser)}
    end

    set_violations(cands)
    return cands
  end

end