# Author: Bruce Tesar
 

require 'test/unit'
require_relative '../lib/candidate'
require_relative '../lib/competition'
require_relative '../lib/competition_list'

class Test_competition_list < Test::Unit::TestCase
  def setup
    # *** input 1 ***
    @win1_1 = Candidate.new("in1", "out1", true, ["C1", "C2"])
    @win1_1.set_viols("C1", 0)
    @win1_1.set_viols("C2", 3)

    @win1_2 = Candidate.new("in1", "out1", true, ["C1", "C2"])
    @win1_2.set_viols("C1", 1)
    @win1_2.set_viols("C2", 4)

    @lose1_1 = Candidate.new("in1", "out1", false, ["C1", "C2"])
    @lose1_1.set_viols("C1", 5)
    @lose1_1.set_viols("C2", 2)

    @lose1_2 = Candidate.new("in1", "out1", false, ["C1", "C2"])
    @lose1_2.set_viols("C1", 6)
    @lose1_2.set_viols("C2", 2)

    @comp1_mult = Competition.new
    @comp1_mult.push(@lose1_2)
    @comp1_mult.push(@win1_1)
    @comp1_mult.push(@win1_2)
    @comp1_mult.push(@lose1_1)

    @comp1_sing = Competition.new
    @comp1_sing.push(@lose1_1)
    @comp1_sing.push(@win1_1)
    @comp1_sing.push(@lose1_2)

    @comp1_none = Competition.new
    @comp1_none.push(@lose1_1)
    @comp1_none.push(@lose1_2)

    # *** input 2 ***
    @win2_1 = Candidate.new("in2", "out2", true, ["C1", "C2"])
    @win2_1.set_viols("C1", 0)
    @win2_1.set_viols("C2", 3)

    @win2_2 = Candidate.new("in2", "out2", true, ["C1", "C2"])
    @win2_2.set_viols("C1", 1)
    @win2_2.set_viols("C2", 4)

    @lose2_1 = Candidate.new("in2", "out2", false, ["C1", "C2"])
    @lose2_1.set_viols("C1", 5)
    @lose2_1.set_viols("C2", 2)

    @lose2_2 = Candidate.new("in2", "out2", false, ["C1", "C2"])
    @lose2_2.set_viols("C1", 6)
    @lose2_2.set_viols("C2", 2)      

    @comp2_mult = Competition.new
    @comp2_mult.push(@lose2_2)
    @comp2_mult.push(@win2_1)
    @comp2_mult.push(@win2_2)
    @comp2_mult.push(@lose2_1)

    @comp2_sing = Competition.new
    @comp2_sing.push(@lose2_1)
    @comp2_sing.push(@win2_1)
    @comp2_sing.push(@lose2_2)

    @comp2_none = Competition.new
    @comp2_none.push(@lose2_1)
    @comp2_none.push(@lose2_2)

  end

  def test_constraint_list
    clist = Competition_list.new
    assert_equal([],clist.constraint_list)
    clist << @comp1_mult
    assert_equal(["C1","C2"],clist.constraint_list)
  end
  
end
