# Author: Bruce Tesar


require 'test/unit'
require_relative '../lib/constraint'

class Test_constraint < Test::Unit::TestCase
  def setup
    @con1 = Constraint.new("FtBin", '1')
    @con2 = Constraint.new("WSP", 2)
    @con3 = Constraint.new("Max", 3)
  end

  def teardown
    # teardown code here
  end

  def test_equals
    con1a = Constraint.new("FtBin", 1)
    assert(@con1==con1a, 'The constraints should be equal.')
    assert(@con1.eql?(con1a), 'The constraints should be equal.')
    con10a = Constraint.new("FtBin", 10)
    assert(@con1==con10a, 'The constraints should be equal.')
    assert((not @con1==@con2), 'The constraints should NOT be equal.')
    assert(@con1!=@con2, 'The constraints should NOT be equal.')
    #
    con2a = Constraint.new("NotWSP", 2)
    assert(@con2!=con2a, 'The constraints should NOT be equal.')
    assert(!@con2.eql?(con2a), 'The constraints should NOT be equal.')
    #
    con2b = Constraint.new("NotWSP", '2')
    assert(@con2!=con2b, 'The constraints should NOT be equal.')
    assert(!@con2.eql?(con2b), 'The constraints should NOT be equal.')
    con2b = Constraint.new("WSP", '2')
    assert(@con2==con2b, 'The constraints should be equal.')
  end

  def test_to_s
    assert_equal("1:FtBin", @con1.to_s)
    assert_equal("2:WSP", @con2.to_s)
  end
  
end
