# Author: Bruce Tesar
# Test selected excel routines.
 

require 'test/unit'
require_relative '../lib/excel'

class Test_excel < Test::Unit::TestCase
  def setup
    @sess = Excel_session.new
    # Create new excel instance; works whether or not excel is already running.
    @excel = WIN32OLE.new("excel.application")
    # Set the excel session to use the new excel instance.
    @sess.instance_variable_set(:@excel,@excel)
    @test_wb = @excel.workbooks.add()
  end

  def teardown
    @test_wb.close(false) # param indicates don't save changes
  end

  def test_name_sheet
    @test_wb.worksheets.add().name = 'Alber{3}'
    @test_wb.worksheets.add().name = 'Alber'
    @test_wb.worksheets.add().name = 'Google'
    @test_wb.worksheets.add().name = 'Alber{x}'
    @test_wb.worksheets.add().name = 'alber{7}'
    @test_wb.worksheets.add().name = 'Albert{8}'
    assert_equal("AlbEr{8}",@sess.name_sheet('A:l\bEr/?'))
  end

end
