# Author: Bruce Tesar
 
require 'test/unit'
require_relative '../lib/fred'
require_relative '../lib/erc'
require_relative '../lib/constraint'
require_relative '../lib/comparative_tableau'
require_relative 'quick_erc'

class Test_fred_step < Test::Unit::TestCase

  # Bring in the quick_erc method and related constants.
  include QuickErc

  def setup
    # setup code here
  end

  def teardown
    # teardown code here
  end

  def test_find_support
    ct = Comparative_tableau.new("test_residue")
    ct.push(erc1 = quick_erc([W,L,E,L],"erc1"))
    ct.push(erc2 = quick_erc([E,W,W,L],"erc2"))
    ct.push(erc3 = quick_erc([W,L,L,W],"erc3"))
    ct.push(erc4 = quick_erc([W,L,W,E],"erc4"))
    fusion = Fred.fuse(ct)
    skb_l = Set.new << Constraint.new("C4", 4)

    f_step = Fred_step.new(fusion,ct,true,skb_l)
    assert_equal(1,f_step.support.size)
    assert_equal('erc3',f_step.support[0].label)
    f_step_expected = <<F_STEP_EXPECTED
Fred step test_residue KEEP? true
FUS: f.test_residue 1:C1:W 2:C2:L 3:C3:L 4:C4:L
SKB: test_residue 1:C1:W 2:C2:L 3:C3:L 4:C4:e
SKB Support:
erc3 1:C1:W 2:C2:L 3:C3:L 4:C4:W
F_STEP_EXPECTED
    assert_equal(f_step_expected, f_step.to_s)
  end

end
