# Author: Bruce Tesar
 
require 'test/unit'
require_relative '../lib/hierarchy'

class Test_hierarchy < Test::Unit::TestCase
  def setup
    # setup code here
  end

  def teardown
    # teardown code here
  end

  def test_foo
    hier = Hierarchy.new
    hier << ["C1", "C2"]
    hier << ["C3"]
    hier << ["C4", "C5", "C6"]
    hier << ["C7", "C8"]
    expect = "[C1 C2] [C3] [C4 C5 C6] [C7 C8]"
    assert_equal(expect, hier.to_s)

    hier << []
    expect = "[C1 C2] [C3] [C4 C5 C6] [C7 C8] []"
    assert_equal(expect, hier.to_s)
  end
  
  def test_dup
    hier = Hierarchy.new
    hier << ["C1", "C2"]
    hier << ["C3"]
    hier << ["C4", "C5", "C6"]
    hier << ["C7", "C8"]
    expect = "[C1 C2] [C3] [C4 C5 C6] [C7 C8]"
    assert_equal(expect, hier.to_s)
    #
    hier_dup = hier.dup
    # the hierarchies have the same to_s
    assert_equal(hier.to_s, hier_dup.to_s)
    # the hierarchies are distinct objects
    assert(!hier_dup.equal?(hier))
    for strat_idx in (0..(hier.size-1)) do
      # corresponding strata are distinct objects
      assert(!hier_dup[strat_idx].equal?(hier[strat_idx]))
      # corresponding constraints are the same object
      for con_idx in (0..(hier[strat_idx].size-1)) do
        assert(hier_dup[strat_idx][con_idx].equal?(hier[strat_idx][con_idx]))
      end
    end
  end

end
