# Author: Naz Merchant
#

require_relative '../../lib/constraint_hs.rb'
require_relative 'constraint_hs_afl.rb'
require_relative 'constraint_hs_afr.rb'
require_relative 'constraint_hs_max_m.rb'
require_relative 'constraint_hs_id_s.rb'
require_relative 'constraint_hs_id_l.rb'
require_relative 'constraint_hs_gen_con1.rb'
require_relative 'constraint_hs_gen_con2.rb'
require_relative 'constraint_hs_gen_con3.rb'

class Constraint_Generator

  def initialize ()
  end
  
  def gen_constraint(name, id, option)
    if option[0..1] == "u."
      obj_name = option[2..-1]
      case obj_name
        when "AFL" then cons = Constraint_HS_AFL.new(name, id, obj_name)
        when "AFR" then cons = Constraint_HS_AFR.new(name, id, obj_name)
        when "Max(m)" then cons = Constraint_HS_Max_M.new(name, id, obj_name)
        when "Id(S)" then cons = Constraint_HS_Id_S.new(name, id, obj_name)
        when "Id(L)" then cons = Constraint_HS_Id_L.new(name, id, obj_name)
        when "con_1" then cons = Constraint_HS_Generic_Con1.new(name, id, obj_name)
        when "con_2" then cons = Constraint_HS_Generic_Con2.new(name, id, obj_name)
        when "con_3" then cons = Constraint_HS_Generic_Con3.new(name, id, obj_name)
       end
    else
      cons = Constraint_HS.new(name, id, Regexp.new(option))
    end
    
    return cons
  end
end