# Author: Naz Merchant
#


require_relative '../../lib/constraint_hs.rb'
require_relative '../../lib/candidate.rb'

class Constraint_HS_Id_L < Constraint_HS
  
  def initialize(name, id, label)
    super(name, id, Regexp.new(label))
    
    @ins  = ["u", "w", "X", "H"]
    @outs = ["w", "u", "H", "X"]
    
  end
  
  def eval(candidate)
    inp = candidate.input
    out = candidate.output
    viols = 0
    for i in 0..out.length
      viols += 1 if viol?(inp[i], out[i])
    end
    return viols
  end
  
  def viol?(in_c, out_c)
    return true if @ins.include?(in_c) && @outs.include?(out_c) && @ins.index(in_c) == @outs.index(out_c)
    return false
  end
end

=begin
input = ".Xh.uH.ug.g.o.w"
output = ".Xu.uX.uH.o.g.x"
con = Constraint_HS_Max_M.new("t", "t", "t")
viols = con.eval(Candidate.new(input, output, false, nil))

puts "Input: \t\t#{input}"
puts "Output: \t#{output}"
puts "Viols:  \t#{viols}"

=end




