# Author: Naz Merchant
#


require_relative '../../lib/constraint_hs.rb'
require_relative '../../lib/candidate.rb'

class Constraint_HS_Max_M < Constraint_HS
  
  def initialize(name, id, label)
    super(name, id, Regexp.new(label))
    
    # Note that a Constraint_HS uses 'label' as a regular expression to match
    # the output of 'candidate' in the method eval. Presumably this obj won't be 
    # doing that.
  end
  
  def eval(candidate)
    inp = candidate.input
    out = candidate.output
    viols = 0
    
    for i in 0..out.length
      if (inp[i] == "g" && out[i] == "o") || (inp[i] == "w" && out[i] == "x") || (inp[i] == "H" && out[i] == "X")
        viols = viols + 1
      end
    end
    return viols
  end
end

=begin
input = ".Xh.uH.ug.g.o.w"
output = ".Xu.uX.uH.o.g.x"
con = Constraint_HS_Max_M.new("t", "t", "t")
viols = con.eval(Candidate.new(input, output, false, nil))

puts "Input: \t\t#{input}"
puts "Output: \t#{output}"
puts "Viols:  \t#{viols}"

=end




