# Author: Nazarre Merchant
#

require_relative 'parser.rb'

# A parser that executes basic epenthsis and elision of single characters.


class BEE_Parser < Parser
  
  def initialize(segs, segs_inputs)
    super(segs, [], segs_inputs, [])
    @segs = segs
    @segs_inputs = segs_inputs
  end
  
  def parse(input)
    return [input]
  end
  
  # Replaces any segments in the output with their input representation, turning
  # an output into a valid input
  def unparse(output)
    input = output.dup
    (0..@segs.length-1).each {|i| input.tr!(@segs[i], @segs_inputs[i])}
    return input
  end
  
  # BEE_Parser is riding on BST_Parser -- TODO: rewrite so constraints&ops of two 
  # systems are different.
  def remove_ineffables(input)
    return input
  end
  
  def remove_invalids(parses)
    return parses
  end
end

