# Author: Nazarre Merchant
#

require_relative '../../lib/candidate_hs.rb'
require_relative 'bst_parser.rb'

# A candidate has an input, an output, and a violation count for each constraint.
# It also has a flag indicating whether it should be optimal, a list of the
# constraints in the system, a label, and a remarks string.
class BST_Candidate < HS_Candidate

  def initialize(input, output, optimal, constraints, operation, parser)
    super(input, output, optimal, constraints, operation)
    @parser = parser
  end

  def output_as_input
    return @parser.unparse(@output)
  end
  
  def is_faithful?
    @input == @parser.unparse(@output)
  end
 
  def dup
    copy = BST_Candidate.new(@input.dup, @output.dup, @opt, @constraints, @operation, @parser)
    copy.base=@base
    @constraints.each{|con| copy.set_viols(con,get_viols(con))}
    copy.label = @label.dup unless @label.nil? # cannot call nil.dup()
    copy.remark = @remark.dup unless @remark.nil?
    # set @merged of the copy to be the same as @merged of the current candidate.
    copy.instance_variable_set(:@merged, @merged)
    # set @merged_candidates of the copy to be A DUPLICATE of
    # @merged_candidates of the current candidate.
    copy.instance_variable_set(:@merge_candidates, @merge_candidates.dup)
    return copy
  end
 
end # class BST_Candidate
