# Author: Naz Merchant
#

# A HS operation that produces the faithful candidate

require_relative '../../lib/operation.rb'

require_relative 'bst_parser.rb'
require_relative 'candidate_bst.rb'

class Faithful_Operation_BEE < Operation

  def initialize(name, source, target, constraints, parser)
    super(name, source, target, constraints)
    @parser = parser
  end

  def create_candidates(input)
    cands = Array.new
    base_set = false
    
    # Produce no faithful candidate if input is invalid output
    # TODO remove this Hack. This only works for Paka, and presumeably 
    # breaks other licit applications of the BEE parser
    
    # Valid outputs have exactly one capital letter in Paka
    
    # ROOPA = richness of operational application
    # Do all operations, including the faithful operation, always apply?
    roopa = true
    if !roopa
      count = 0
      input.split("").each {|c| count = count + 1 if /[A-Z]/.match(c) != nil}
      return cands if count != 1
    end

    @parser.parse(input).each do |out| 
      c = BST_Candidate.new(input, out, false, @cons, self, @parser)
      # Arb. choose first faith cand to be base
      c.base=true unless base_set
      base_set = true
      cands << c
    end
    
    set_violations(cands)
    return cands
  end

end