# Author: Naz Merchant
#

# A HS operation that produces the faithful candidate

require_relative '../../lib/operation.rb'

require_relative 'bst_parser.rb'
require_relative 'candidate_bst.rb'

class Faithful_Operation_BST < Operation

  def initialize(name, source, target, constraints, parser)
    super(name, source, target, constraints)
    @parser = parser
  end

  def create_candidates(input)
    cands = Array.new
    base_set = false
    @parser.parse(input).each do |out| 
      c = BST_Candidate.new(input, out, false, @cons, self, @parser)
      # Arb. choose first faith cand to be base
      c.base=true unless base_set
      base_set = true  
      cands << c if @parser.contains_syllabified_segs_only(out)
      cands << c if out == ""
    end
    
    set_violations(cands)
    return cands
  end

end